// A Queue Class Ferworn CPS109 Fall 2001

public class Queue
{ 
	Queue_List first;
	Queue_List last;
	String queue_name;

	public Queue(String name)
	{
		// Make a new queue
		queue_name=name;
		first= null;
		last= null;
	}
	
	public void join(int val, String name)
	{
		Queue_List temp = new Queue_List();
		temp.val = val;
		temp.name = name;

		if(first == null)
		{
			first = temp;
			last = temp;
			temp.next = null;
			temp.prev = null;
		}
		else
		{
			temp.prev = last;
			temp.next = null;
			last.next = temp;
			last = temp;
		}
	}

	public Queue_List leave()
	{
		Queue_List temp = first;
		if(temp == null) return null; //empty queue
		first = first.next;
		return temp;
	}
		
	public void dump_queue()
	{
	    // note: dumping a queue is not normal, why?
		Queue_List node = first;
		System.out.println("The queue " + 
			queue_name + " looks like this...");
		System.out.print("first->");
		while(node!= null)
		{
			System.out.print("<-(" + node.val + 
				"," + node.name + ")" + "->");
			node=node.next;
		}
		System.out.print("<-last\n");
	}
}



