// A simple singly linked list showing adding nodes and deleting them.
// Ferworn CPS109 Fall 2000, amended Fall 2011
public class SLinker
{ 
	public static void traverse(SList node)
	{
		System.out.println("The list looks like this...");
		while(node!= null)
		{
			System.out.print(node.val + "->");
			node=node.next;
		}
		System.out.print("null");
		System.out.print("\n\n");
	}
	public static void main(String[] args)
	{ 
		SList first = null;//Instance variable showing first in list
		SList temp;
		SList will_be_killed;
		SList after_killed;
		traverse(first);

		// add first node
		temp = new SList();
		temp.val = 0;
		temp.next = first;
		first = temp;
		traverse(first);
		after_killed = first;
  
		// add second node
		temp = new SList();
		temp.val = 1;
		temp.next = first;
		first = temp;
		traverse(first);
		will_be_killed = first;

		// add third node
		temp = new SList();
		temp.val = 2;
		temp.next = first;
		first = temp;
		traverse(first);
	
		// kill second node
		first.next = after_killed;
		traverse(first);		

		// Replace killed node with another node
		temp = new SList();
		temp.val = 999;
		temp.next = after_killed;
		first.next = temp;
		traverse(first);				

		// kill that node afain
		first.next = first.next.next;
		traverse(first);
	}
}

/* Output will be
The list looks like this...
null

The list looks like this...
0->null

The list looks like this...
1->0->null

The list looks like this...
2->1->0->null

The list looks like this...
2->0->null

The list looks like this...
2->999->0->null

The list looks like this...
2->0->null

*/
